// Vegetation GEO
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _296
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 0, std140) uniform _43_45
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _45;

layout(set = 0, binding = 0, std140) uniform _57_59
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _59;

layout(set = 1, binding = 0, std140) uniform _113_115
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _115;

layout(set = 0, binding = 1, std430) restrict readonly buffer _298_300
{
    _296 _m0[];
} _300;

layout(push_constant, std430) uniform _301_303
{
    int _m0;
    int _m1;
} _303;

layout(set = 0, binding = 2) uniform sampler _1046;

layout(location = 0) in vec4 _33;
layout(location = 3) in vec4 _98;
layout(location = 1) in vec2 _355;
layout(location = 12) in vec2 _357;
layout(location = 2) out vec4 _365;
layout(location = 14) flat out uvec3 _372;
layout(location = 10) out vec4 _708;
layout(location = 11) out vec4 _1038;

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

mat4 _19(mat4 _17, mat4 _18)
{
    return _17 * _18;
}

void main()
{
    vec4 _31 = vec4(_33.xyz, 1.0);
    bool _54 = _45._m0.x != 0.0;
    bool _65;
    if (_54)
    {
        _65 = _59._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _65 = _54;
    }
    bool _72;
    if (_65)
    {
        _72 = _45._m1.x > 0.0;
    }
    else
    {
        _72 = _65;
    }
    if (_72)
    {
        vec3 _76 = vec3(_59._m0.xy, 0.0);
        float _86 = _45._m0.x;
        float _89 = _45._m0.y;
        float _93 = _45._m0.w;
        vec4 _97 = _98;
        float _100 = _45._m1.x;
        float _103 = _45._m1.y;
        float _106 = _45._m1.z;
        float _109 = _45._m1.w;
        vec4 _116 = _31;
        vec4 _118 = _115._m0;
        vec4 _112;
        _112.x = _12(_116, _118);
        vec4 _123 = _31;
        vec4 _125 = _115._m1;
        _112.y = _12(_123, _125);
        vec4 _131 = _31;
        vec4 _133 = _115._m2;
        _112.z = _12(_131, _133);
        _112.w = 1.0;
        float _139 = dot(_112.xyz, _76) * _100;
        float _146 = _97.z * _109;
        float _151 = _115._m0.w * _115._m1.w;
        float _157 = ((_59._m1.x * _45._m0.z) * _100) - _139;
        float _167 = (_97.x * 1.0) - _146;
        float _173 = sin(_157 - _167);
        float _178 = sin((_157 * 1.33000004291534423828125) - _167);
        float _185 = ((_173 + _178) * 0.25) + 0.5;
        _185 *= _185;
        float _196 = (_185 * (_89 - _86)) + _86;
        vec3 _204 = _76 * vec3(_196);
        float _209 = ((_97.y * 16.0) - _151) - _146;
        float _218 = sin(((_59._m1.x * 4.0) * _103) + _209);
        float _228 = cos(((_59._m1.x * 3.3299999237060546875) * _103) + _209);
        float _238 = (_218 + _228) * (-_97.w);
        vec3 _246 = vec3(_218 * _93, _228 * _93, _238 * _106) * vec3(_196);
        vec3 _260 = ((_204 + _246) * _59._m0.z) * _97.z;
        vec3 _273 = _112.xyz + _260;
        _112 = vec4(_273.x, _273.y, _273.z, _112.w);
        _112.w = 1.0;
        _31.x = dot(_112, _115._m3);
        _31.y = dot(_112, _115._m4);
        _31.z = dot(_112, _115._m5);
    }
    vec4 _295 = _300._m0[_303._m1]._m0;
    vec4 _309 = _300._m0[_303._m1]._m1;
    vec4 _314 = _300._m0[_303._m1]._m2;
    vec4 _319 = _300._m0[_303._m1]._m3;
    vec4 _328 = _31;
    vec4 _330 = _295;
    gl_Position.x = _12(_328, _330);
    vec4 _335 = _31;
    vec4 _337 = _309;
    gl_Position.y = _12(_335, _337);
    vec4 _341 = _31;
    vec4 _343 = _314;
    gl_Position.z = _12(_341, _343);
    vec4 _347 = _31;
    vec4 _349 = _319;
    gl_Position.w = _12(_347, _349);
    vec4 _353 = vec4(_355, _357);
    _365 = _353 + _45._m2;
    _372 = uvec3(0u);
    float _374 = _59._m1.x;
    float _377 = _59._m1.x - _59._m1.y;
    mat4 _383 = mat4(vec4(_115._m0), vec4(_115._m1), vec4(_115._m2), vec4(_115._m6));
    mat4 _414 = mat4(vec4(_59._m2), vec4(_59._m3), vec4(_59._m4), vec4(_59._m5));
    mat4 _445 = _383;
    mat4 _447 = _414;
    mat4 _444 = _19(_445, _447);
    vec4 _450 = _444[0];
    vec4 _453 = _444[1];
    vec4 _456 = _444[2];
    vec4 _459 = _444[3];
    vec4 _462 = vec4(_33.xyz, 1.0);
    bool _471 = _45._m0.x != 0.0;
    bool _477;
    if (_471)
    {
        _477 = _59._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _477 = _471;
    }
    bool _483;
    if (_477)
    {
        _483 = _45._m1.x > 0.0;
    }
    else
    {
        _483 = _477;
    }
    if (_483)
    {
        vec3 _486 = vec3(_59._m0.xy, 0.0);
        float _493 = _45._m0.x;
        float _496 = _45._m0.y;
        float _499 = _45._m0.w;
        vec4 _502 = _98;
        float _504 = _45._m1.x;
        float _507 = _45._m1.y;
        float _510 = _45._m1.z;
        float _513 = _45._m1.w;
        vec4 _517 = _462;
        vec4 _519 = _115._m0;
        vec4 _516;
        _516.x = _12(_517, _519);
        vec4 _524 = _462;
        vec4 _526 = _115._m1;
        _516.y = _12(_524, _526);
        vec4 _531 = _462;
        vec4 _533 = _115._m2;
        _516.z = _12(_531, _533);
        _516.w = 1.0;
        float _539 = dot(_516.xyz, _486) * _504;
        float _546 = _502.z * _513;
        float _551 = _115._m0.w * _115._m1.w;
        float _557 = ((_374 * _45._m0.z) * _504) - _539;
        float _566 = (_502.x * 1.0) - _546;
        float _572 = sin(_557 - _566);
        float _577 = sin((_557 * 1.33000004291534423828125) - _566);
        float _583 = ((_572 + _577) * 0.25) + 0.5;
        _583 *= _583;
        float _592 = (_583 * (_496 - _493)) + _493;
        vec3 _600 = _486 * vec3(_592);
        float _605 = ((_502.y * 16.0) - _551) - _546;
        float _613 = sin(((_374 * 4.0) * _507) + _605);
        float _621 = cos(((_374 * 3.3299999237060546875) * _507) + _605);
        float _629 = (_613 + _621) * (-_502.w);
        vec3 _637 = vec3(_613 * _499, _621 * _499, _629 * _510) * vec3(_592);
        vec3 _651 = ((_600 + _637) * _59._m0.z) * _502.z;
        vec3 _664 = _516.xyz + _651;
        _516 = vec4(_664.x, _664.y, _664.z, _516.w);
        _516.w = 1.0;
        _462.x = dot(_516, _115._m3);
        _462.y = dot(_516, _115._m4);
        _462.z = dot(_516, _115._m5);
    }
    vec4 _684 = _462;
    vec4 _686 = _450;
    vec4 _683;
    _683.x = _12(_684, _686);
    vec4 _690 = _462;
    vec4 _692 = _453;
    _683.y = _12(_690, _692);
    vec4 _696 = _462;
    vec4 _698 = _456;
    _683.z = _12(_696, _698);
    vec4 _702 = _462;
    vec4 _704 = _459;
    _683.w = _12(_702, _704);
    _708 = _683;
    mat4 _710 = mat4(vec4(_115._m7), vec4(_115._m8), vec4(_115._m9), vec4(_115._m10));
    mat4 _744 = mat4(vec4(_59._m6), vec4(_59._m7), vec4(_59._m8), vec4(_59._m9));
    mat4 _775 = _710;
    mat4 _777 = _744;
    mat4 _774 = _19(_775, _777);
    vec4 _780 = _774[0];
    vec4 _783 = _774[1];
    vec4 _786 = _774[2];
    vec4 _789 = _774[3];
    vec4 _792 = vec4(_33.xyz, 1.0);
    bool _801 = _45._m0.x != 0.0;
    bool _807;
    if (_801)
    {
        _807 = _59._m0.z > 0.001000000047497451305389404296875;
    }
    else
    {
        _807 = _801;
    }
    bool _813;
    if (_807)
    {
        _813 = _45._m1.x > 0.0;
    }
    else
    {
        _813 = _807;
    }
    if (_813)
    {
        vec3 _816 = vec3(_59._m0.xy, 0.0);
        float _823 = _45._m0.x;
        float _826 = _45._m0.y;
        float _829 = _45._m0.w;
        vec4 _832 = _98;
        float _834 = _45._m1.x;
        float _837 = _45._m1.y;
        float _840 = _45._m1.z;
        float _843 = _45._m1.w;
        vec4 _847 = _792;
        vec4 _849 = _115._m0;
        vec4 _846;
        _846.x = _12(_847, _849);
        vec4 _854 = _792;
        vec4 _856 = _115._m1;
        _846.y = _12(_854, _856);
        vec4 _861 = _792;
        vec4 _863 = _115._m2;
        _846.z = _12(_861, _863);
        _846.w = 1.0;
        float _869 = dot(_846.xyz, _816) * _834;
        float _876 = _832.z * _843;
        float _881 = _115._m0.w * _115._m1.w;
        float _887 = ((_377 * _45._m0.z) * _834) - _869;
        float _896 = (_832.x * 1.0) - _876;
        float _902 = sin(_887 - _896);
        float _907 = sin((_887 * 1.33000004291534423828125) - _896);
        float _913 = ((_902 + _907) * 0.25) + 0.5;
        _913 *= _913;
        float _922 = (_913 * (_826 - _823)) + _823;
        vec3 _930 = _816 * vec3(_922);
        float _935 = ((_832.y * 16.0) - _881) - _876;
        float _943 = sin(((_377 * 4.0) * _837) + _935);
        float _951 = cos(((_377 * 3.3299999237060546875) * _837) + _935);
        float _959 = (_943 + _951) * (-_832.w);
        vec3 _967 = vec3(_943 * _829, _951 * _829, _959 * _840) * vec3(_922);
        vec3 _981 = ((_930 + _967) * _59._m0.z) * _832.z;
        vec3 _994 = _846.xyz + _981;
        _846 = vec4(_994.x, _994.y, _994.z, _846.w);
        _846.w = 1.0;
        _792.x = dot(_846, _115._m3);
        _792.y = dot(_846, _115._m4);
        _792.z = dot(_846, _115._m5);
    }
    vec4 _1014 = _792;
    vec4 _1016 = _780;
    vec4 _1013;
    _1013.x = _12(_1014, _1016);
    vec4 _1020 = _792;
    vec4 _1022 = _783;
    _1013.y = _12(_1020, _1022);
    vec4 _1026 = _792;
    vec4 _1028 = _786;
    _1013.z = _12(_1026, _1028);
    vec4 _1032 = _792;
    vec4 _1034 = _789;
    _1013.w = _12(_1032, _1034);
    _1038 = _1013;
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


