#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

struct _107
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 1, std430) restrict readonly buffer _109_111
{
    _107 _m0[];
} _111;

layout(set = 1, binding = 0, std140) uniform _172_174
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _174;

layout(set = 0, binding = 0, std140) uniform _263_265
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _265;

layout(set = 0, binding = 14, std430) restrict readonly buffer _327_329
{
    uint _m0[];
} _329;

layout(set = 0, binding = 15, std140) uniform _332_334
{
    vec4 _m0[4096];
} _334;

layout(set = 0, binding = 16, std140) uniform _336_338
{
    vec4 _m0[4096];
} _338;

layout(set = 0, binding = 17, std140) uniform _340_342
{
    vec4 _m0[4096];
} _342;

layout(set = 0, binding = 19, std140) uniform _345_347
{
    vec4 _m0[4096];
} _347;

layout(set = 0, binding = 20, std140) uniform _349_351
{
    vec4 _m0[4096];
} _351;

layout(set = 0, binding = 21, std140) uniform _354_356
{
    vec4 _m0[3072];
} _356;

layout(set = 0, binding = 23, std140) uniform _360_362
{
    vec4 _m0[4095];
} _362;

layout(set = 0, binding = 25, std140) uniform _368_370
{
    vec4 _m0[4096];
} _370;

layout(set = 2, binding = 0, std140) uniform _372_374
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _374;

layout(push_constant, std430) uniform _114_116
{
    int _m0;
    int _m1;
} _116;

layout(set = 0, binding = 2) uniform sampler _310;
layout(set = 0, binding = 3) uniform sampler _311;
layout(set = 0, binding = 4) uniform sampler _312;
layout(set = 0, binding = 5) uniform sampler _313;
layout(set = 0, binding = 6) uniform sampler _314;
layout(set = 0, binding = 7) uniform sampler _315;
layout(set = 0, binding = 8) uniform sampler _316;
layout(set = 0, binding = 9) uniform sampler2D _320;
layout(set = 0, binding = 10) uniform sampler2D _321;
layout(set = 0, binding = 11) uniform sampler2D _322;
layout(set = 0, binding = 12, r32f) uniform readonly writeonly image2D _325;
layout(set = 0, binding = 18) uniform sampler2D _343;
layout(set = 0, binding = 22) uniform sampler2D _357;
layout(set = 0, binding = 24) uniform sampler2DShadow _366;
layout(set = 0, binding = 26) uniform sampler2D _371;

layout(location = 15) out vec4 _46;
layout(location = 14) flat out uvec3 _54;
layout(location = 2) out vec4 _61;
layout(location = 1) in vec2 _64;
layout(location = 12) in vec2 _67;
layout(location = 0) in vec4 _72;
layout(location = 2) in vec4 _81;
layout(location = 9) in vec4 _88;
layout(location = 3) out vec4 _171;
layout(location = 4) out vec4 _202;
layout(location = 5) out vec4 _270;
layout(location = 3) in vec4 _279;
layout(location = 6) out vec4 _299;

float _19(vec4 _17, vec4 _18)
{
    return dot(_17, _18);
}

float _14(vec3 _12, vec4 _13)
{
    return dot(_12, _13.xyz);
}

void main()
{
    vec4 _32 = vec4(0.0);
    vec3 _35 = vec3(0.0);
    uvec2 _40 = uvec2(0u);
    uint _44 = 0u;
    _46 = vec4(_35, 0.0);
    _54 = uvec3(_40.x, _40.y, 0u);
    _61 = _64.xyxy;
    _61 = vec4(_61.x, _61.y, _67.x, _67.y);
    _32 = vec4(_72.xyz, 1.0);
    vec4 _80 = (_81 * 2.0) - vec4(1.0);
    vec4 _87 = (_88 * 2.0) - vec4(1.0);
    _87.w = (floor((_88.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    vec4 _106 = _111._m0[_116._m1]._m0;
    vec4 _124 = _111._m0[_116._m1]._m1;
    vec4 _129 = _111._m0[_116._m1]._m2;
    vec4 _135 = _111._m0[_116._m1]._m3;
    vec4 _145 = _32;
    vec4 _147 = _106;
    gl_Position.x = _19(_145, _147);
    vec4 _152 = _32;
    vec4 _154 = _124;
    gl_Position.y = _19(_152, _154);
    vec4 _158 = _32;
    vec4 _160 = _129;
    gl_Position.z = _19(_158, _160);
    vec4 _165 = _32;
    vec4 _167 = _135;
    gl_Position.w = _19(_165, _167);
    vec3 _176 = _80.xyz;
    vec4 _179 = _174._m5;
    _171.x = _14(_176, _179);
    vec3 _185 = _80.xyz;
    vec4 _188 = _174._m6;
    _171.y = _14(_185, _188);
    vec3 _194 = _80.xyz;
    vec4 _197 = _174._m7;
    _171.z = _14(_194, _197);
    vec3 _203 = _87.xyz;
    vec4 _206 = _174._m5;
    _202.x = _14(_203, _206);
    vec3 _211 = _87.xyz;
    vec4 _214 = _174._m6;
    _202.y = _14(_211, _214);
    vec3 _219 = _87.xyz;
    vec4 _222 = _174._m7;
    _202.z = _14(_219, _222);
    _202.w = sign(_87.w * (-_174._m12.x));
    vec4 _238 = _32;
    vec4 _240 = _174._m5;
    vec4 _237;
    _237.x = _19(_238, _240);
    vec4 _245 = _32;
    vec4 _247 = _174._m6;
    _237.y = _19(_245, _247);
    vec4 _252 = _32;
    vec4 _254 = _174._m7;
    _237.z = _19(_252, _254);
    _237.w = 1.0;
    vec3 _260 = _237.xyz - _265._m0.xyz;
    _270 = vec4(_270.x, _270.y, _260.xy.x, _260.xy.y);
    _171.w = _260.z;
    vec4 _278 = _279;
    float _285;
    if (_278.w < 1.0)
    {
        _285 = _278.w * 16.0;
    }
    else
    {
        _285 = 1.0;
    }
    vec3 _296 = _278.xyz * _285;
    _278 = vec4(_296.x, _296.y, _296.z, _278.w);
    _299 = vec4(_278.xyz.x, _278.xyz.y, _278.xyz.z, _299.w);
    gl_Position.y = -gl_Position.y;

    // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}


