// MORE UI
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 1, binding = 0, std140) uniform _116_118
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _118;

layout(set = 0, binding = 0, std140) uniform _164_166
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _166;

layout(set = 2, binding = 0, std140) uniform _305_307
{
    vec4 _m0;
} _307;

layout(push_constant, std430) uniform _325_327
{
    int _m0;
    int _m1;
} _327;

layout(set = 2, binding = 1) uniform sampler2D _331;

layout(location = 0) in vec4 _228;
layout(location = 2) out vec4 _294;
layout(location = 1) in vec2 _296;
layout(location = 0) out vec4 _304;
layout(location = 3) in vec4 _314;

float _63;

mat4 _37(mat4 _35, mat4 _36)
{
    return _35 * _36;
}

float _12(vec4 _10, vec4 _11)
{
    return dot(_10, _11);
}

float _17(float _16)
{
    if (_16 <= 0.040449999272823333740234375)
    {
        return _16 / 12.9200000762939453125;
    }
    else
    {
        return pow((_16 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _23(vec3 _22)
{
    float _65 = _22.x;
    vec3 _64;
    _64.x = _17(_65);
    float _72 = _22.y;
    _64.y = _17(_72);
    float _78 = _22.z;
    _64.z = _17(_78);
    return _64;
}

vec4 _27(vec4 _26)
{
    vec3 _88 = _26.xyz;
    vec4 _87 = vec4(_23(_88), 1.0);
    float _97 = _26.w;
    _87.w = _17(_97);
    return _87;
}

vec4 _30(vec4 _29)
{
    vec4 _106 = _29;
    return _27(_106);
}

void main()
{
    vec4 _202;
    vec4 _205;
    vec4 _208;
    vec4 _211;
    if (_118._m0.x > 0.0)
    {
        mat4 _128 = mat4(vec4(_118._m1), vec4(_118._m2), vec4(_118._m3), vec4(_118._m4));
        mat4 _163 = mat4(vec4(_166._m0), vec4(_166._m1), vec4(_166._m2), vec4(_166._m3));
        mat4 _197 = _128;
        mat4 _199 = _163;
        mat4 _196 = _37(_197, _199);
        _202 = _196[0];
        _205 = _196[1];
        _208 = _196[2];
        _211 = _196[3];
    }
    else
    {
        _202 = _118._m1;
        _205 = _118._m2;
        _208 = _118._m3;
        _211 = _118._m4;
    }
    vec4 _229 = _228;
    vec4 _231 = _202;
    gl_Position.x = _12(_229, _231);
    vec4 _236 = _228;
    vec4 _238 = _205;
    gl_Position.y = _12(_236, _238);
    vec4 _242 = _228;
    vec4 _244 = _208;
    gl_Position.z = _12(_242, _244);
    vec4 _248 = _228;
    vec4 _250 = _211;
    gl_Position.w = _12(_248, _250);
    vec2 _256 = _118._m5.xy;
    vec2 _261 = normalize(gl_Position.xy - _256);
    vec2 _279 = gl_Position.xy + (_261 * (_118._m5.w * _118._m5.z));
    gl_Position = vec4(_279.x, _279.y, gl_Position.z, gl_Position.w);
    vec3 _283 = gl_Position.xyz - _166._m4.xyz;
    float _291 = length(_283);
    _294 = vec4(_296.x, _296.y, _291, 0.0);
    vec4 _311;
    if (_307._m0.x > 0.0)
    {
        vec4 _315 = _314;
        _311 = _30(_315);
    }
    else
    {
        _311 = _314;
    }
    _304 = _311;
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
gl_Position.x += vk3d_params[VIEW].stereo.x * vk3d_params[VIEW].custom_params.x;
}


